Package org.spongepowered.asm.service

## Interface IMixinAuditTrail

-     public interface IMixinAuditTrail

  Audit trail is responsible for logging activities during mixin application to target classes for use as debugging information later on. An audit trail service can either log audit entries internally for retrieval on crash, or can delegate to an underlying subsystem which handles this behaviour.

  This service component is entirely optional and services can elect to return `null` if the platform does not support this functionality.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `onApply​(java.lang.String className, java.lang.String mixinName)` | Called when a class has a mixin applied to it by mixin.
    `void` | `onGenerate​(java.lang.String className, java.lang.String generatorName)` | Called when a class is generated by mixin.
    `void` | `onPostProcess​(java.lang.String className)` | Called when a class is post-processed by mixin.

- - ### Method Detail

    - #### onApply

          void onApply​(java.lang.String className,
                       java.lang.String mixinName)

      Called when a class has a mixin applied to it by mixin.
      Parameters:
        `className` - Target class name
        `mixinName` - Mixin name

    - #### onPostProcess

          void onPostProcess​(java.lang.String className)

      Called when a class is post-processed by mixin. This is the case for synthetic inner classes (eg. switch table) and for accessor interfaces.
      Parameters:
        `className` - Class being post-processed

    - #### onGenerate

          void onGenerate​(java.lang.String className,
                          java.lang.String generatorName)

      Called when a class is generated by mixin. This is the case for fully synthetic classes such as Args and non-synthetic inner classes in mixins
      Parameters:
        `className` - Class being generated
        `generatorName` - Name of the generator